<div class="container-fluid">
  <div class="row">
    <!--Filters-->
    <div class="border-bottom-xl-rigth
                col-12 pt-4 pb-1
                col-xl-3">
      <app-filters-presets
          [selectedReportingFilters]="selectedReportingFilters"
          (selectedReportingFiltersChange)="selectedReportingFiltersChange($event)"
          (selectedReportingFiltersReset)="selectedReportingFiltersReset()"
        ></app-filters-presets>
      <div class="filter-wrapper">
        <div class="form-group d-flex justify-content-between align-items-center">
          <label>Date:</label>
          <app-calendar [(dateRange)]="calendarDateRange"></app-calendar>
        </div>
        <div class="form-group d-flex justify-content-between align-items-center">
          <label>Users:</label>
          <p-multiSelect
            [options]="users"
            optionLabel="label"
            optionValue="value"
            placeholder="Select users"
            [(ngModel)]="selectedUserIds"
            [style]="{'width':'178px'}"
            class="multiSelect"
          >
            <ng-template let-selectedItems pTemplate="selectedItems">
              <span *ngIf="selectedUserIds?.length === users?.length; else selectedCount">
                All selected
              </span>
              <ng-template #selectedCount>
                <span>
                  {{selectedUserIds?.length || 0}} selected
                </span>
              </ng-template>
            </ng-template>
          </p-multiSelect>
        </div>
        <div class="form-group d-flex justify-content-between align-items-center">
          <label>Projects:</label>
          <p-multiSelect
            [options]="projects"
            optionLabel="label"
            optionValue="value"
            placeholder="Select projects"
            [(ngModel)]="selectedProjectIds"
            [style]="{'width':'178px'}"
            class="multiSelect"
          >
            <ng-template let-selectedItems pTemplate="selectedItems">
              <span *ngIf="selectedProjectIds?.length === projects?.length; else selectedCount">
                All selected
              </span>
              <ng-template #selectedCount>
                <span>
                  {{selectedProjectIds?.length || 0}} selected
                </span>
              </ng-template>
            </ng-template>
          </p-multiSelect>
        </div>
        <div class="form-group d-flex align-items-center gap-5 flex-wrap" *ngIf="hasRWPermission">
          <p-checkbox [style]="{'margin-right':'5px'}" [(ngModel)]="this.isExternalOnly" [binary]="true"
                      label="External only"
          />
          <p-checkbox [style]="{'margin-right':'5px'}" [(ngModel)]="this.isShowInactiveUsers" [binary]="true"
                      label="Show inactive users"
                      (onChange)="this.onShowInactiveUsersChange($event)"
          />
        </div>
        <div class="form-group d-flex align-items-center flex-wrap">
          <p-button class="mr-3" label="Apply" (click)="apply()"></p-button>
        </div>
      </div>
    </div>
    <!--Data-->
    <div class="p-py-5
                col-12
                col-xl-9">
      <div class="form-group">
        <p-table [scrollable]="true" [value]="totals" [autoLayout]="true" styleClass="p-datatable-striped">
          <ng-template pTemplate="header">
            <tr>
              <th>Account / Project</th>
              <th>Sum Internal</th>
              <th>Sum External</th>
            </tr>
          </ng-template>
          <ng-template pTemplate="body" let-total>
            <tr>
              <td>{{total.project.account.name}} / {{total.project.name}}</td>
              <td>{{total.sumInternal}}</td>
              <td>{{total.sumExternal}}</td>
            </tr>
          </ng-template>
          <ng-template pTemplate="footer" let-columns>
            <tr>
              <td>
                Total
              </td>
              <td>
                {{totalInternal}}
              </td>
              <td>
                {{totalExternal}}
              </td>
            </tr>
          </ng-template>
        </p-table>
      </div>

      <div class="form-group">
        <div class="d-flex justify-content-start" style="float: left;">
          <p-button *ngIf="timeReportBatchCommits.length && hasTimeReportHistoryPermission" icon="fa fa-history" label="History" (click)="showHistoryDialog()"></p-button>
        </div>
        <div class="d-flex justify-content-end">
          <div class="d-flex justify-content-between" style="width: 145px;">
            <button pButton icon="fa fa-file-excel-o" [disabled]="!selectedTimeReports?.length" (click)="onExportExcel()"></button>
            <button pButton icon="fa fa-file-word-o" [disabled]="!selectedTimeReports?.length" (click)="onExportWord()"></button>
            <button [disabled]="!hasWritePermission" pButton icon="fa fa-plus" (click)="onAddTimeReport()"></button>
            <button pButton icon="fa fa-pencil" [disabled]="!selectedTimeReports?.length || !hasWritePermission" (click)="onEditTimeReports()"></button>
            <button pButton icon="fa fa-times" [disabled]="!selectedTimeReports?.length || !hasWritePermission" (click)="onDeleteTimeReports()" class="p-button-danger"></button>
          </div>
        </div>
      </div>

      <p-table [scrollable]="true" [value]="timeReports" [style]="{width:'100%'}" [autoLayout]="true" [(selection)]="selectedTimeReports"styleClass="p-datatable-striped">
        <ng-template pTemplate="header">
          <tr>
            <th style="width: 3em">
              <p-tableHeaderCheckbox></p-tableHeaderCheckbox>
            </th>
            <th>Date</th>
            <th>User</th>
            <th>Account / Project</th>
            <th style="white-space: nowrap">Int. / Ext.</th>
            <th>Description</th>
            <th>Overhead</th>
          </tr>
        </ng-template>
        <ng-template pTemplate="body" let-report>
          <tr [pSelectableRow]="report">
            <td>
              <p-tableCheckbox [value]="report"></p-tableCheckbox>
            </td>
            <td>{{report.reportingDate | date:'shortDate'}}</td>
            <td>{{report.user.firstName}} {{report.user.lastName}}</td>
            <td>{{report.project.account.name}} / {{report.project.name}}</td>
            <td>{{report.internalHours}} / {{report.externalHours}}</td>
            <td style="white-space: pre-line">{{report.workDescription}}</td>
            <td>{{report.isOverhead ? 'Yes' : 'No'}}</td>
          </tr>
        </ng-template>
        <ng-template pTemplate="emptymessage">
          <tr>
            <td colspan="7">
              No records found
            </td>
          </tr>
        </ng-template>
      </p-table>
    </div>
  </div>
</div>
<p-dialog #addDialog
          [(visible)]="addDialogVisible"
          [responsive]="true"
          [resizable]="false"
          [focusOnShow]="false"
          showEffect="fade"
          [modal]="true"
          [style]="{ 'width': '600px' }"
         >
  <div class="p-p-5" style="height: 550px;">
    <div class="form-group d-flex justify-content-between">
      <div class="align-self-center">User</div>
      <p-dropdown optionValue="value"
                  optionLabel="label"
                  [(ngModel)]="this.addModel.userId"
                  [options]="addDropdownUsers"
                  [style]="{ 'width': '400px' }"
                  (onChange)="validateAdd()"
                  [filter]="true"
      ></p-dropdown>
    </div>
    <div class="form-group d-flex justify-content-between">
      <div class="align-self-center">Project</div>
      <p-dropdown optionValue="value"
                  optionLabel="label"
                  [(ngModel)]="this.addModel.projectId"
                  [options]="addDropdownProjects"
                  [style]="{ 'width': '400px' }"
                  (onChange)="validateAdd()"
                  [filter]="true"
      ></p-dropdown>
    </div>
    <div class="form-group d-flex justify-content-between">
      <div class="align-self-center">Date</div>
      <p-calendar [locale]="globals.calendarLocale" [(ngModel)]="addReportingDate" [style]="{'width':'400px'}" [inputStyle]="{'width':'100%'}"></p-calendar>
    </div>

    <div class="form-group">
      <div class="d-flex justify-content-between">
        <div class="align-self-center">Internal</div>
        <p-inputNumber
          [(ngModel)]="addModel.internal"
          [showButtons]="true"
          mode="decimal"
          styleClass="add-time-report-input"
          [min]="0"
          [useGrouping]="false"
          [maxFractionDigits]="1"
          [step]="0.5"
          (ngModelChange)="validateAdd()"
        ></p-inputNumber>
      </div>
      <div *ngIf="!isAddInternalValid" class="invalid-feedback d-block text-right mt-1">
        {{hoursErrorMessage}}
      </div>
    </div>

    <div class="form-group">
      <div class="d-flex justify-content-between">
        <div class="align-self-center">External</div>
        <p-inputNumber
          [(ngModel)]="addModel.external"
          [showButtons]="true"
          mode="decimal"
          styleClass="add-time-report-input"
          [min]="0"
          [useGrouping]="false"
          [maxFractionDigits]="1"
          [step]="0.5"
          (ngModelChange)="validateAdd()"
          [disabled]="isInternalProject(this.addModel.projectId)"
        ></p-inputNumber>
      </div>
      <div *ngIf="!isAddExternalValid" class="invalid-feedback d-block text-right mt-1">
        {{hoursErrorMessage}}
      </div>
    </div>

    <div class="form-group d-flex justify-content-between">
      <label>Description</label>
      <textarea
      [(ngModel)]="addModel.workDescription"
      pInputTextarea
      [rows]="3"
      class="add-time-report-work-description-textarea"
    ></textarea>

    </div>

    <div class="p-my-5 form-group d-flex justify-content-between">
      <div>
        <button pButton label="Cancel" (click)="hideAddDialog()" class="p-button-warning"></button>
      </div>
      <div class="d-flex gap-2 justify-content-end">
        <button pButton label="Reset" (click)="resetAddModel()" class="p-button-outlined"></button>
        <button pButton label="Save" [disabled]="isAddButtonDisabled" (click)="onAddTimeReportSave()"></button>
      </div>
    </div>
  </div>
</p-dialog>
<p-dialog #editDialog
  [(visible)]="editDialogVisible"
  [responsive]="true"
  [resizable]="false"
  [focusOnShow]="false"
  showEffect="fade"
  [modal]="true"
  [style]="{ 'width': '600px' }"
  [contentStyle]="{ 'height': 'auto', 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'visible' }">
  <div class="p-4">
    <div class="form-group mb-3">
      <div class="d-flex justify-content-between align-items-center">
        <p-checkbox label="Set project" [(ngModel)]="editModel.setProject" [binary]="true"></p-checkbox>
        <app-filter-dropdown
          [options]="editDropdownProjects"
          [(selectedItem)]="editModel.selectedProjectId"
          [style]="{ 'width': '350px' }"
          [disabled]="!editModel.setProject"
          (selectedItemChange)="validateEdit()"
        ></app-filter-dropdown>
      </div>
    </div>
    <div class="form-group mb-3">
      <div class="d-flex justify-content-between align-items-center">
        <p-checkbox label="Set internal" [(ngModel)]="editModel.setInternal" [binary]="true" (onChange)="onSetInternalChange()"></p-checkbox>
        <p-inputNumber
          [(ngModel)]="editModel.internal"
          [disabled]="!editModel.setInternal"
          [showButtons]="true"
          mode="decimal"
          styleClass="edit-time-report-input"
          [min]="0"
          [useGrouping]="false"
          [maxFractionDigits]="1"
          [step]="0.5"
          (ngModelChange)="validateEdit()"
        ></p-inputNumber>
      </div>
      <div *ngIf="!isEditInternalValid" class="invalid-feedback d-block text-right mt-1">
        {{hoursErrorMessage}}
      </div>
    </div>
    <div class="form-group mb-3">
      <div class="d-flex justify-content-between align-items-center">
        <p-checkbox label="Set external" [(ngModel)]="editModel.setExternal" [binary]="true" (onChange)="onSetExternalChange()"></p-checkbox>
        <p-inputNumber
          [(ngModel)]="editModel.external"
          [disabled]="!editModel.setExternal"
          [showButtons]="true"
          mode="decimal"
          styleClass="edit-time-report-input"
          [min]="0"
          [useGrouping]="false"
          [maxFractionDigits]="1"
          [step]="0.5"
          (ngModelChange)="validateEdit()"
        ></p-inputNumber>
      </div>
      <div *ngIf="!isEditExternalValid" class="invalid-feedback d-block text-right mt-1">
        {{hoursErrorMessage}}
      </div>
    </div>
    <div class="form-group d-flex gap-2 justify-content-between mt-4">
      <button pButton label="Cancel" (click)="hideEditDialog()" class="p-button-warning"></button>
      <button pButton label="Save" [disabled]="isEditButtonDisabled" (click)="onEditTimeReportsSave()"></button>
    </div>
  </div>
</p-dialog>
<p-dialog #historyDialog
          [(visible)]="historyDialogVisible"
          [responsive]="true"
          [resizable]="false"
          [focusOnShow]="false"
          showEffect="fade"
          [modal]="true"
          [style]="{ 'width': '800px' }"
          [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }"
          header="History">
      <p-table [scrollable]="true" [value]="timeReportBatchCommits" [autoLayout]="true" styleClass="p-datatable-striped">
        <ng-template pTemplate="header">
            <tr>
                <th></th>
                <th>Editor</th>
                <th>Date</th>
                <th>Action</th>
                <th *ngIf="hasTimeReportHistoryPermission"></th>
            </tr>
        </ng-template>
        <ng-template pTemplate="body" let-commit>
            <tr>
                <td>
                  <button pButton label="More" (click)="onTimeReportBatchCommitDetails(commit.id)" class="p-button-success"></button>
                </td>
                <td>{{commit.editorFullName}}</td>
                <td>{{commit.dateTime | date:'dd/MM/yyyy hh:mm:ss'}}</td>
                <td>{{commit.editAction}}</td>
                <td>
                  <button pButton icon="fa fa-times" (click)="onRevertTimeReportBatchCommit(commit.id)" class="p-button-danger"></button>
                </td>
            </tr>
            <tr *ngIf="selectedTimeReportBatchCommitDetailsId === commit.id">
              <td colspan="5">

              <p-table [scrollable]="true" [value]="selectedTimeReportBatchCommitDetails" [autoLayout]="true" styleClass="p-datatable-striped">
                <ng-template pTemplate="header">
                  <tr>
                    <th>Date</th>
                    <th>User</th>
                    <th>Project From</th>
                    <th>Project To</th>
                    <th>Int From</th>
                    <th>Int To</th>
                    <th>Ext From</th>
                    <th>Ext To</th>
                    <th>Work Description</th>
                </tr>
                </ng-template>
                <ng-template pTemplate="body" let-reportDiff>
                  <tr>
                    <td>{{reportDiff.reportingDate | date:'d/M/yy'}}</td>
                    <td>{{reportDiff.userFullname}}</td>
                    <td>{{reportDiff.projectFrom}}</td>
                    <td>{{reportDiff.projectTo}}</td>
                    <td>{{reportDiff.intFrom}}</td>
                    <td>{{reportDiff.intTo}}</td>
                    <td>{{reportDiff.extFrom}}</td>
                    <td>{{reportDiff.extTo}}</td>
                    <td>{{reportDiff.workDescFrom}}</td>
                  </tr>
                </ng-template>
              </p-table>
            </td>
            </tr>
        </ng-template>
      </p-table>
</p-dialog>

